package b4a.ouya;

import tv.ouya.console.api.OuyaController;
import android.view.MotionEvent;
import android.view.View;
import android.view.animation.DecelerateInterpolator;
import anywheresoftware.b4a.AbsObjectWrapper;
import anywheresoftware.b4a.BA;
import anywheresoftware.b4a.BA.ActivityObject;
import anywheresoftware.b4a.BA.DependsOn;
import anywheresoftware.b4a.BA.Events;
import anywheresoftware.b4a.BA.ShortName;
import anywheresoftware.b4a.keywords.Common;

@DependsOn(values={"ouya-sdk"})
@ActivityObject
@Events(values={"GenericMotion (Event As MotionEvent)"})
@ShortName("Ouya")
public class Ouya{
	private String eventName;
	public int AXIS_LS_2 = OuyaController.AXIS_L2;
	public int AXIS_LS_X = OuyaController.AXIS_LS_X;
	public int AXIS_LS_Y = OuyaController.AXIS_LS_Y;
	public int AXIS_R2 = OuyaController.AXIS_R2;
	public int AXIS_RS_X = OuyaController.AXIS_RS_X;
	public int AXIS_RS_Y = OuyaController.AXIS_RS_Y;
	public void Initialize(final BA ba, final String EventName) {
		OuyaController.init(ba.context);
		eventName = EventName.toLowerCase(BA.cul);
		ba.vg.requestFocus();
		ba.vg.setOnGenericMotionListener(new View.OnGenericMotionListener() {

			@Override
			public boolean onGenericMotion(View arg0, MotionEvent arg1) {
				MotionEventWrapper m = new MotionEventWrapper();
				m.setObject(arg1);
				ba.raiseEvent(Ouya.this, eventName + "_genericmotion", m);
				return true;
			}
			
		});
	}
	public int GetPlayerNumByDeviceId(int DeviceId) {
		return OuyaController.getPlayerNumByDeviceId(DeviceId);
	}
	@ShortName("MotionEvent")
	public static class MotionEventWrapper extends AbsObjectWrapper<MotionEvent> {
		public float GetAxisValue(int Axis) {
			return getObject().getAxisValue(Axis);
		}
		public int GetDeviceId() {
			return getObject().getDeviceId();
		}
	}
	
}
  